﻿makemods = LibStub("AceAddon-3.0"):NewAddon("MakeMods")
local L = LibStub("AceLocale-3.0"):GetLocale("MakeMods", true)

function options()
	local options = {
	    name = "MakeMods",
	    handler = makemods,
	    type = "group",
	    args = {
	        header = {
	            order = 1,
	            type = "description",
	            name = L["Notes"],
	            image = "Interface\\Icons\\achievement_guildperk_everyones-a-hero_rank2",
	            imageWidth = 32,
	            imageHeight = 32,
	        },
	        extralinebreak = {
	            order = 2,
	            type = "description",
	            name = "\n",
	        },
	        byguildrank = {
	        	order = 3,
	        	type = "multiselect",
	        	name = L["PromoteGuildRanks"],
	        	values = function() end,
	        	get = function() end,
	        	set = function() end,
	        },
	    },
	}
	LibStub("AceConfig-3.0"):RegisterOptionsTable("MakeMods", options, nil)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("MakeMods")
end

function makemods:OnInitialize()
  -- Code that you want to run when the addon is first loaded goes here.
end

function makemods:OnEnable()
    -- Called when the addon is enabled
end

function makemods:OnDisable()
    -- Called when the addon is disabled
end

local mm = {}
local playerarrived = false

local function msg(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg)
end

function makemods_onload(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	self:RegisterEvent("CALENDAR_ACTION_PENDING")
end

local function kdn()
	local guild = GetGuildInfo("player")
	local faction = UnitFactionGroup("player")
	local realm = GetRealmName()
	if guild == "Kinder der Nacht" and faction == "Horde" and realm == "Das Konsortium" then
		return true
	end
	return false
end

local function makemods()
	if mm then
		local inv = CalendarEventGetNumInvites()
		local invitee, ismod = nil
		for i=1, inv do
			invitee,_,_,_,_,ismod = CalendarEventGetInvite(i)
			for _,v in ipairs(mm) do
				if invitee == v and invitee ~= GetUnitName("player") and CalendarEventCanModerate(i) and ismod ~= "MODERATOR" and ismod ~= "CREATOR" then
					CalendarEventSetModerator(i)
				end
			end
		end
	end
end

function makemods_onevent(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" then
		playerarrived = true
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	elseif event == "GUILD_ROSTER_UPDATE" then
		if playerarrived then
			mm = {}
			local num = GetNumGuildMembers(1)
			if num > 0 then
				for i = 1, num do
					local rostername, rosterrank, rosterrankindex = GetGuildRosterInfo(i)
					if rostername and rosterrankindex <= 3 then
						table.insert(mm, rostername)
					end
				end
			end
		else
			GuildRoster()
		end
	elseif event == "CALENDAR_ACTION_PENDING" then
		if kdn() then
			makemods()
		end
	end
end